#property indicator_chart_window
#property indicator_buffers 4
#property indicator_color1 Red
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_color4 Blue

extern int       ma_period=5;
extern int       period=8;

double FrUP[];
double FrDN[];

double AvUP[];
double AvDN[];

int init()
  {
    SetIndexBuffer(0,FrUP);
    SetIndexBuffer(1,FrDN);   
    SetIndexBuffer(2,AvUP);
    SetIndexBuffer(3,AvDN);       
    SetIndexStyle(0,DRAW_ARROW);   //   
    SetIndexArrow(0,241);
    SetIndexStyle(1,DRAW_ARROW);
    SetIndexArrow(1,242);
    SetIndexStyle(2,DRAW_LINE);   //   
    SetIndexStyle(3,DRAW_LINE);   //   
    SetIndexLabel(0,"FrUp MedianPrice");
    SetIndexLabel(1,"FrDown MedianPrice");
   return(0);
  }

int deinit()
  {
   return(0);
  }
  
//double Average(int ma_shift, int shift);

int start()
  {
   int  i, nCountedBars;
   bool   bFound;
   nCountedBars=IndicatorCounted();
   if(nCountedBars<=2)
      i=Bars-nCountedBars-3;
   if(nCountedBars>2)
     {
      nCountedBars--;
      i=Bars-nCountedBars-1;
     }
   while(i>=0)                //   
     {
      FrUP[i]=0;FrDN[i]=0;       
//     5- 
      if(High[i]>High[i+1] && High[i]>High[i+2] && High[i]>High[i-1] && High[i]>High[i-2]) 
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+1]+Low[i+1])/2+(High[i+2]+Low[i+2])/2)/5;}
//     6- 
      if(High[i]==High[i+1] && High[i]>High[i+2] && High[i]>High[i+3] && High[i]>High[i-1] && High[i]>High[i-2])
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+3]+Low[i+3])/2+(High[i+2]+Low[i+2])/2+(High[i+1]+Low[i+1])/2)/6;}     
//     7- 
      if(High[i]>=High[i+1] && High[i]==High[i+2] && High[i]>High[i+3] && High[i]>High[i+4] && High[i]>High[i-1] && High[i]>High[i-2])
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+4]+Low[i+4])/2+(High[i+3]+Low[i+3])/2+(High[i+2]+Low[i+2])/2+(High[i+1]+Low[i+1])/2)/7;}
//     8- 
      if(High[i]>=High[i+1] && High[i]>=High[i+2] && High[i]==High[i+3] && High[i]>High[i+4] && High[i]>High[i+5] && High[i]>High[i-1] && High[i]>High[i-2])
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+5]+Low[i+5])/2+(High[i+4]+Low[i+4])/2+(High[i+3]+Low[i+3])/2+(High[i+2]+Low[i+2])/2+(High[i+1]+Low[i+1])/2)/8;}
//     9- 
      if(High[i]>=High[i+1] && High[i]>=High[i+2] && High[i]>=High[i+3] && High[i]>=High[i+4] && High[i]>High[i+5] && High[i]>High[i+6] && High[i]>High[i-1] && High[i]>High[i-2])
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+6]+Low[i+6])/2+(High[i+5]+Low[i+5])/2+(High[i+4]+Low[i+4])/2+(High[i+3]+Low[i+3])/2+(High[i+2]+Low[i+2])/2+(High[i+1]+Low[i+1])/2)/9;}
//     10- 
     if(High[i]>=High[i+1] && High[i]>=High[i+2] && High[i]>=High[i+3] && High[i]>=High[i+4] && High[i]>=High[i+5] && High[i]>High[i+6] && High[i]>High[i+7] && High[i]>High[i-1] && High[i]>High[i-2])
        {FrUP[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+7]+Low[i+7])/2+(High[i+6]+Low[i+6])/2+(High[i+5]+Low[i+5])/2+(High[i+4]+Low[i+4])/2+(High[i+3]+Low[i+3])/2+(High[i+2]+Low[i+2])/2+(High[i+1]+Low[i+1])/2)/10;}

//     5- 
      if(Low[i]<Low[i-1] && Low[i]<Low[i-2] && Low[i]<Low[i+1] && Low[i]<Low[i+2])
        {FrDN[i]=((Low[i+2]+High[i+2])/2+(Low[i+1]+High[i+1])/2+(Low[i]+High[i])/2+(Low[i-1]+High[i-1])/2+(Low[i-2]+High[i-2])/2)/5;}
//     6- 
      if(Low[i]<Low[i+2] && Low[i]<Low[i+3] && Low[i]==Low[i+1] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
        {FrDN[i]=((High[i-2]+Low[i-2])/2+(High[i-1]+Low[i-1])/2+(High[i]+Low[i])/2+(High[i+1]+Low[i+1])/2+(High[i+2]+Low[i+2])/2+(High[i+3]+Low[i+3])/2)/6;}
//     7- 
      if(Low[i]<=Low[i+1] && Low[i]<=Low[i+2] && Low[i]<Low[i+3] && Low[i]<Low[i+4] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
        {FrDN[i]=((Low[i-2]+High[i-2])/2+(Low[i-1]+High[i-1])/2+(Low[i]+High[i])/2+(Low[i+1]+High[i+1])/2+(Low[i+2]+High[i+2])/2+(Low[i+3]+High[i+3])/2+(Low[i+4]+High[i+4])/2)/7;}
//     8- 
      if(Low[i]<=Low[i+1] && Low[i]<=Low[i+2] && Low[i]<=Low[i+3] && Low[i]<Low[i+4] && Low[i]<Low[i+5] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
        {FrDN[i]=((Low[i-2]+High[i-2])/2+(Low[i-1]+High[i-1])/2+(Low[i]+High[i])/2+(Low[i+1]+High[i+1])/2+(Low[i+2]+High[i+2])/2+(Low[i+3]+High[i+3])/2+(Low[i+4]+High[i+4])/2+(Low[i+5]+High[i+5])/2)/8;}
//     9- 
      if(Low[i]<=Low[i+1] && Low[i]<=Low[i+2] && Low[i]<=Low[i+3] && Low[i]<=Low[i+4] && Low[i]<Low[i+5] && Low[i]<Low[i+6] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
        {FrDN[i]=((Low[i-2]+High[i-2])/2+(Low[i-1]+High[i-1])/2+(Low[i]+High[i])/2+(Low[i+1]+High[i+1])/2+(Low[i+2]+High[i+2])/2+(Low[i+3]+High[i+3])/2+(Low[i+4]+High[i+4])/2+(Low[i+5]+High[i+5])/2+(Low[i+6]+High[i+6])/2)/9;}
//     10- 
      if(Low[i]<=Low[i+1] && Low[i]<=Low[i+2] && Low[i]<=Low[i+3] && Low[i]<=Low[i+4] && Low[i]<=Low[i+5] && Low[i]<Low[i+6] && Low[i]<Low[i+7] && Low[i]<Low[i-1] && Low[i]<Low[i-2])
        {FrDN[i]=((Low[i-2]+High[i-2])/2+(Low[i-1]+High[i-1])/2+(Low[i]+High[i])/2+(Low[i+1]+High[i+1])/2+(Low[i+2]+High[i+2])/2+(Low[i+3]+High[i+3])/2+(Low[i+4]+High[i+4])/2+(Low[i+5]+High[i+5])/2+(Low[i+6]+High[i+6])/2+(Low[i+7]+High[i+7])/2)/10;}
        
     int j=i;int count=period;
     double summ=0;
     while (j<Bars){
       if (FrDN[j]!=0) {
         summ+=FrDN[j];
         count--;          
       }
       if (count<=0) break;
       j++;
     }
     AvUP[i-ma_period]=summ/period; 
    

     j=i;count=period;
     summ=0;
     while (j<Bars){
       if (FrUP[j]!=0) {
         summ+=FrUP[j];
         count--;          
       }
       if (count<=0) break;
       j++;
     }
     AvDN[i-ma_period]=summ/period; 
  
        
      i--;
     }
   return(0);
 }